/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.FuncionSistema;
import com.rjconsultores.ventaboletos.entidad.Sistema;
import com.rjconsultores.ventaboletos.service.SistemaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMenu;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 * 
 * @author rodrigo
 */
@Controller("busquedaMenuController")
@Scope("prototype")
public class BusquedaMenuController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<FuncionSistema> plwMenu;
	@Autowired
	private SistemaService sistemaService;
	private MyListbox menuList;
	private Paging pagingMenu;
	private Textbox txtNombFuncion;
	private Textbox txtDescRuta;
	private Combobox cmbSistema;
	private Intbox txtID;
	private List<Sistema> lsSistema;

	public Combobox getCmbSistema() {
		return cmbSistema;
	}

	public void setCmbSistema(Combobox cmbSistema) {
		this.cmbSistema = cmbSistema;
	}

	public MyListbox getMenuList() {
		return menuList;
	}

	public void setMenuList(MyListbox menuList) {
		this.menuList = menuList;
	}

	public Textbox getTxtDescRuta() {
		return txtDescRuta;
	}

	public void setTxtDescRuta(Textbox txtDescRuta) {
		this.txtDescRuta = txtDescRuta;
	}

	public Intbox getTxtID() {
		return txtID;
	}

	public void setTxtID(Intbox txtID) {
		this.txtID = txtID;
	}

	public Textbox getTxtNombFuncion() {
		return txtNombFuncion;
	}

	public void setTxtNombFuncion(Textbox txtNombFuncion) {
		this.txtNombFuncion = txtNombFuncion;
	}

	public List<Sistema> getLsSistema() {
		return lsSistema;
	}

	public void setLsSistema(List<Sistema> lsSistema) {
		this.lsSistema = lsSistema;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsSistema = sistemaService.obtenerTodos();

		menuList.setItemRenderer(new RenderMenu());
		menuList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				FuncionSistema s = (FuncionSistema) menuList.getSelected();
				verMenu(s);
			}
		});

		refreshLista();

		txtNombFuncion.focus();
	}

	private void verMenu(FuncionSistema fs) {
		if (fs == null) {
			return;
		}

		Map args = new HashMap();
		args.put("menu", fs);
		args.put("menuList", menuList);

		openWindow("/gui/seguridad/editarMenu.zul",
				Labels.getLabel("editarMenuController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<FuncionSistema> menuBusqueda =
				new HibernateSearchObject<FuncionSistema>(FuncionSistema.class,
						pagingMenu.getPageSize());

		String nombFuncion = txtNombFuncion.getText();
		if (nombFuncion != null) {
			menuBusqueda.addFilterLike("nombfuncion", "%" + nombFuncion.trim().concat("%"));
		}

		String descRuta = txtDescRuta.getText();
		if (descRuta != null) {
			menuBusqueda.addFilterLike("descruta", "%" + descRuta.trim().concat("%"));
		}

		Comboitem itemSistema = cmbSistema.getSelectedItem();
		if (itemSistema != null) {
			Sistema sistema = (Sistema) itemSistema.getValue();
			menuBusqueda.addFilterEqual("sistema", sistema);
		}

		menuBusqueda.addFilterEqual("funcionsistemaId", txtID.getValue());

		menuBusqueda.addSortAsc("nombfuncion");
		menuBusqueda.addFilterEqual("activo", Boolean.TRUE);

		plwMenu.init(menuBusqueda, menuList, pagingMenu);

		if (menuList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaMenuController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verMenu(new FuncionSistema());
	}
}
